/*************************************************************************
*  Program:       NEW.C                                                  *
*  Description:   Template for VieNet2-Applications for DOS              *
*  Last modified: 20.2.94                                                *
*  Version:       2.0                                                    *
*  Author:        LG                                                     *
**************************************************************************/

/* Reihenfolge der Headerfiles muss eingehalten werden! */
#include "neurodef.h"
#include "neurons.h"
#include "nngraph.h"

pINT A,B;  /* Layervariablen global definieren */

/*-----------------------------------------------------------------------*/
void save()
{ save_weights("current.wgt"); }

void load()
{ load_weights("current.wgt"); }

void reset_all()
{ reset_layers();
  draw_layers();
}

void nextpat_A()
{ next_pattern(A); draw_ext(A); }

void prevpat_A()
{ prev_pattern(A); draw_ext(A); }

void randompat_A()
{ rand_pat(A); draw_ext(A); }

/* Verbindungen aufbauen und initialisieren,
   MUSS immer definiert werden! */
void connect_all_new()
{ nnconnect(A,B,FULL,-1.0,1.0,0.5);
  nnconnect(B,B,COMP,-0.2,-0.2,1.0);
}

/* Interactiv activation update */
void upd1()
{ update(A,A,EXT,STANDARD);
  update(A,B,IAC,ALL);
  copy();
  draw_layers();
}

/* standard update using activation function f() */
void upd2()
{ update(A,A,EXT,STANDARD);
  /* dont use ALL here, because you have internal connections in layer B! */
  update(A,B,STANDARD,SINGLE);
  copy();
  draw_layers();
}

void learn()
{ pINT i,j;
  for (L_ALL(A,i))
    for (L_ALL(B,j))
      if ((X(A,i) > 0.5) && (X(A,j) > 0.5))
				W(A,B,i,j) += 0.02;
      else
			  W(A,B,i,j) -= 0.02;
}

/*------------------------------------------------------------------------*/
/* define network, buttons, etc. */
void nn_init(int argc, char** argv)
{
  A = init_layer(10,1,GRID,20,100,"A-Layer"); /* Layer erzeugen - noch keine Anzeige! */
  B = init_layer(20,1,GRID,20,50,"B-Layer");

  L_Tab[A].extsep_x = 3;   /* relative Position des Externlayers evtl. aendern */
  L_Tab[A].extsep_y = 40;

  connect_all_new();       /* Alle Gewichte aufbauen und init */

  make_button("QUIT",shutdown,'Q');      /* Alle gewuenschten Buttons definieren */
                                                                                                                                                   /* Nicht auf QUIT o.ae. vergessen! */
  make_button("New WGTS",connect_all_new,'W');
  make_button("Reset",reset_all,'R');
  make_button("upd1",upd1,'1');
  make_button("upd2",upd2,'2');
  make_button("Next INP",nextpat_A,'N');
  make_button("Prev INP",prevpat_A,'P');
  make_button("LEARN",learn,'L');

  make_pattern(A,"1000000000"); /* haendische Testmuster festlegen */
  make_pattern(A,"0100000001");
  make_pattern(A,"0010000010");
  make_pattern(A,"0101100000");
  make_pattern(A,"0100011001");
  make_pattern(A,"0110000110");
  first_pattern(A);

/* ODER:
   automatisch mehrere Bilder laut Schedule-File laden
   load_schedule("new.scd",A);
*/
  draw_layers();         /* Alle Layer anzeigen */
  pprintf("This is a demo of VieNet2 %s\n\n",VERSION);
  wait_for_action();     /* Eingabeschleife */
}

#ifndef WIN
void main(int argc, char** argv)
{ nn_setup(argc,argv);
  nn_init(argc,argv);}
#endif
