/*************************************************************************
*  Program:       NNCONTRL.CPP                                           *
*  Description:   additional controls for VieNet2 using Windows 3.1      *
*  Version:       1.4                                                    *
*  Last modified: 26.6.93                                                *
*  Author:        LG                                                     *
*  Copyright (C) Austrian Research Institute for Artificial Intelligence *
**************************************************************************/

#define WIN31

#define SCALE_VAL(x) ((int)((1.0-((x)-min)/scale)*height+R.top))

#include <owl.h>
#include <bwcc.h>
#include <bwindow.h>
#include <bgrpbox.h>
#include <bstatic.h>
#include <stdio.h>
#include <string.h>

#define BAR_WIDTH 30
#include "nncontrl.h"

/* implements a 3-level bar for make_meter3(..) */
TBar::TBar(PTWindowsObject AParent, char* Text,
		int x, int y, int w, int h,
		float lim1, float lim2,
		float val, float from, float to):TBWindow(AParent,NULL)
{Attr.X=x; Attr.Y=y; Attr.W=w; Attr.H=h;
 Attr.Style = WS_BORDER | WS_CHILD | WS_VISIBLE;
 value=val;limit1=lim1;limit2=lim2;min=from;max=to;
 Title=Text;
}

TBar::~TBar()
{}

void TBar::GetWindowClass(WNDCLASS& AWndClass)
{TBWindow::GetWindowClass(AWndClass);
// AWndClass.hbrBackground=(HBRUSH)GetStockObject(GRAY_BRUSH);
}


void TBar::WMCreate(RTMessage Msg)
{       TBWindow::WMCreate(Msg);
//  new TBGroupBox(this->Parent,1,"",Attr.X,Attr.Y,Attr.W,Attr.H);

//  new TBGroupBox(this->Parent,1,"",Attr.X+5,Attr.Y+5,Attr.W-10,14);
	new TBGroupBox(this->Parent,1,"",Attr.X+4,Attr.Y+4,Attr.W-8,18);
	PTitle=new TBStatic(this->Parent,1,Title,Attr.X+5,Attr.Y+5,Attr.W-10,14,strlen(Title));
	PTitle->Attr.Style=(PTitle->Attr.Style & ~SS_LEFT) | SS_CENTER;

	new TBGroupBox(this->Parent,1,"",Attr.X+4,Attr.Y+Attr.H-4-18,Attr.W-8,18);
	PDiag=new TBStatic(this->Parent,1,"",Attr.X+5,Attr.Y+Attr.H-3-18,Attr.W-10,14,0);
	PDiag->Attr.Style=(PDiag->Attr.Style & ~SS_LEFT) | SS_CENTER;
	new TBStatic(this->Parent,1,"CAD",Attr.X+BAR_WIDTH+5+50,Attr.Y+30,3*10,14,0);
	new TBStatic(this->Parent,1,"Normal",Attr.X+BAR_WIDTH+5+50,Attr.Y+Attr.H-5-30-14,6*10,14,0);
}

void TBar::Paint( HDC PaintDC, PAINTSTRUCT& PaintInfo)
{ TBWindow::Paint( PaintDC,  PaintInfo);

//  SetBkColor(PaintDC,RGB(255,0,0));
//  SetBkMode(PaintDC,OPAQUE);

	RECT R,R0;
	HBRUSH hB1;
	char val[10];
	SetRect(&R0,Attr.X,Attr.Y,Attr.X+Attr.W,Attr.Y+Attr.H);
	R0.top-=17;
	R0.bottom-=17;
//      CopyRect(&R0,&PaintInfo.rcPaint);
/*
	HPEN hP=CreatePen(PS_SOLID,2,RGB(255,255,255));
	HANDLE OldP = SelectObject(PaintDC,hP);
	Rectangle(PaintDC,R0.left,R0.top,R0.right,R0.bottom);
	DeleteObject(SelectObject(PaintDC,OldP));
*/
	R0.left+=10;
	R0.right= R0.left+BAR_WIDTH;
	R0.top+=25;
	R0.bottom-=25;
	CopyRect(&R,&R0);

	float height=R.bottom-R.top;
	float scale=max-min;

//  Rectangle(DrawInfo.hDC,R.left,R.top,R.right,R.bottom);

	hB1=CreateSolidBrush(RGB(255,0,0));
	R.bottom=SCALE_VAL(limit2)+2;
	FillRect(PaintDC,&R,hB1); //Upper Red
//      Rectangle(DrawInfo.hDC,R.left,R.right,R.top,R.bottom);
//      DeleteObject(SelectObject(DrawInfo.hDC,hOld));
	DeleteObject(hB1);

	CopyRect(&R,&R0);
	R.bottom=SCALE_VAL(limit1)+1;
	R.top=SCALE_VAL(limit2)+1;
	hB1=CreateSolidBrush(RGB(128,128,128)); // Mid Gray
	FillRect(PaintDC,&R,hB1);
	DeleteObject(hB1);

	CopyRect(&R,&R0);
	R.top=SCALE_VAL(limit1)+1;
	R.bottom+=1;
	hB1=CreateSolidBrush(RGB(0,255,0)); // Lower Green
	FillRect(PaintDC,&R,hB1);
	DeleteObject(hB1);

	// Clear old lines
	CopyRect(&R,&R0);
	R.left=R.right+1;
	R.right+=25;
	R.bottom+=1;
	hB1=CreateSolidBrush(RGB(192,192,192));
	FillRect(PaintDC,&R,hB1);
	DeleteObject(hB1);

	// Draw lines to static text
	CopyRect(&R,&R0);
	MoveTo(PaintDC,R.right+1,SCALE_VAL(limit2+(max-limit2)/2));
	LineTo(PaintDC,R.right+25,Attr.Y+30);
	LineTo(PaintDC,R.right+57,Attr.Y+30);

	MoveTo(PaintDC,R.right+1,SCALE_VAL(min+(limit1-min)/2));
	LineTo(PaintDC,R.right+25,Attr.Y+Attr.H-50);
	LineTo(PaintDC,R.right+77,Attr.Y+Attr.H-50);

	if (value>=min && value<=max)
		{// Show and mark value
 //             sprintf(val,"%.2f",value);
//        SetBkColor(PaintDC,RGB(150,150,150));
//              DrawText(PaintDC, val, -1, &PaintInfo.rcPaint,
//                      DT_CENTER | DT_VCENTER);
		CopyRect(&R,&R0);
		R.top+=1;
		height-=2;
		HPEN hP=CreatePen(PS_SOLID,3,RGB(0,0,0));
		HANDLE OldP = SelectObject(PaintDC,hP);
		MoveTo(PaintDC,R.left+1,SCALE_VAL(value));
		LineTo(PaintDC,R.right-2,SCALE_VAL(value));
		DeleteObject(SelectObject(PaintDC,OldP));
		if (value<=limit1) PDiag->SetText("Normal");
		else if (value>=limit2) PDiag->SetText("CAD");
			else PDiag->SetText("Unsicher");
		}

	if (!(Title[0]=='@')) PTitle->SetText(Title);
//              DrawText(PaintDC, Title, -1, &PaintInfo.rcPaint,DT_BOTTOM | DT_SINGLELINE);

}


void TBar::SetValue(float val, float lim1, float lim2, float from, float to, char* Text)
{       value=val;
	if (lim1<=lim2 && from<to && from<=lim1 && lim2<=to)
		{limit1=lim1; limit2=lim2; min=from; max=to;}
	if (!(Text[0]=='@')) strcpy(Title,Text);
	InvalidateRect(HWindow,NULL,FALSE);
}
