/*************************************************************************
*  Program:       NNSound.c                                              *
*  Description:   Soundfunctions for VieNet2                             *
*  Version:       V1.5                                                   *
*  Last modified: 1.10.93                                                *
*  Author:        LG                                                     *
**************************************************************************/

#define WIN31
#include <owl.h>
#include <mmsystem.h>

WORD wDeviceID = 0;
BOOL flushNotify = FALSE;

MCI_GENERIC_PARMS	MciGenParm;
MCI_OPEN_PARMS		MciOpenParm;
MCI_PLAY_PARMS		MciPlayParm;
MCI_STATUS_PARMS	MciStatusParm;
MCI_SET_PARMS			MciSetParm;

int running=FALSE;

void StopWave()
{
	MciGenParm.dwCallback = 0L;
	mciSendCommand (wDeviceID, MCI_STOP, MCI_WAIT,
      (DWORD)(LPMCI_GENERIC_PARMS)&MciGenParm);
	mciSendCommand (wDeviceID, MCI_CLOSE, MCI_WAIT,
      (DWORD)(LPMCI_GENERIC_PARMS)&MciGenParm);

	running = FALSE;
  wDeviceID = 0;
}

void PlayWave (char* filename)
{	if (wDeviceID) StopWave();

		MciOpenParm.dwCallback = 0L;
		MciOpenParm.wDeviceID = 0;
		MciOpenParm.wReserved0 = 0;
		MciOpenParm.lpstrDeviceType = NULL;
		MciOpenParm.lpstrElementName = filename;
		MciOpenParm.lpstrAlias = NULL;

		if (mciSendCommand (0, MCI_OPEN, (DWORD) (MCI_WAIT | MCI_OPEN_ELEMENT),
         (DWORD)(LPMCI_OPEN_PARMS)&MciOpenParm))
			{
			MessageBox (GetActiveWindow(),
          "Open Error - a waveForm output device is necessary to use this demo.",
          "Sound Play", MB_OK);
			return;
			}
   	wDeviceID = MciOpenParm.wDeviceID;
    MciSetParm.dwCallback = 0L;
		MciSetParm.dwTimeFormat = MCI_FORMAT_SAMPLES;
    if (mciSendCommand (wDeviceID, MCI_SET, MCI_SET_TIME_FORMAT,
         (DWORD)(LPMCI_SET_PARMS)&MciSetParm))
			{
			MessageBox (GetActiveWindow(), "SetTime Error", "Sound Play", MB_OK);
			return;
    	}

		MciPlayParm.dwCallback = (unsigned long)GetActiveWindow();
		MciPlayParm.dwFrom = 0;
		MciPlayParm.dwTo = 0;
		mciSendCommand (wDeviceID, MCI_PLAY, MCI_NOTIFY,
         (DWORD) (LPMCI_PLAY_PARMS)&MciPlayParm);
}
